import { IMap } from './global';
declare class Is {
    null(value: any): value is null;
    null<T>(value: T, defaultValue: () => T): T;
    notNull<T>(...values: (() => T)[]): T;
    function(value: any): value is Function;
    function<T>(value: any, defaultValue: T): T;
    array(value: any): value is any[];
    array<T>(value: any, defaultValue: () => T[]): T[];
    promise(value: any): value is Promise<any>;
    keyValuePair(value: any): boolean;
    object(value: any): value is object;
    plainObject(value: any): value is object;
    date(value: any): value is Date;
    date(value: any, defaultValue: Date): Date;
    boolean(value: any): value is boolean;
    boolean(value: any, defaultValue: boolean): boolean;
    string(value: any): value is string;
    string(value: any, defaultValue: string): string;
    string(value: any, defaultValue: () => string): string;
    string<T>(value: any, isString: (value: string) => T, notString: () => T): T;
    stringAndNotEmpty(value: any): value is string;
    stringAndNotEmpty(value: any, defaultValue: string): string;
    stringAndNotEmpty(value: any, defaultValue: () => string): string;
    stringAndNotEmpty<T>(value: any, isStringAndNotEmpty: (value: string) => T, notString: () => T): T;
    empty(value: string): boolean;
    empty(value: string, defaultValue: string): string;
    empty(value: string, defaultValue: () => string): string;
    empty<T>(value: string, isEmpty: () => T, isNotEmpty: (value: string) => T): T;
    error(value: IMap): value is Error;
    number(value: any): value is number;
    number(value: any, defaultValue: number): number;
    number(value: any, defaultValue: number, min: number, max: number): number;
    number(value: any, defaultValue: () => number): number;
    number<T>(value: any, isNumber: (value: number) => T, isNotNumber: () => T): T;
    enum(value: any, enumDefinition: any): boolean;
    enum<TEnum>(value: any, enumDefinition: any, defaultValue: TEnum): TEnum;
    primitive(value: any): value is string | number | boolean;
    private parseArguments;
}
export declare let is: Is;
export {};
//# sourceMappingURL=is.d.ts.map