import './object';
export declare enum PropertyAccess {
    CanRead = 0,
    CanWrite = 1
}
declare global {
    namespace Reflect {
        interface IEndOfPathAction {
            value: any;
            shouldContinue: boolean;
        }
        interface ITypeOf<T = any> {
            type: string;
            isArray: boolean;
            isObject: boolean;
            isPrototype: boolean;
            isInstance: boolean;
            isNull: boolean;
            isUndefined: boolean;
            isNullOrUndefined: boolean;
            isBoolean: boolean;
            isNumber: boolean;
            isString: boolean;
            isPrimitive: boolean;
            isFunction: boolean;
            isDate: boolean;
            value: T;
        }
        function isOrDerivesFrom(source: any, derivesFrom: any): boolean;
        function className(instance: any): string;
        function getDefinition(target: any, memberKey: PropertyKey): PropertyDescriptor;
        function getAllDefinitionsForMember(target: any, memberName: string): PropertyDescriptor[];
        function getAllDefinitions(target: any): PropertyDescriptorMap;
        function getProperty<T>(target: any, propertyName: string): T;
        function getProperty<T>(target: any, propertyName: string, defaultValue: T): T;
        function getProperty<T>(target: any, propertyName: string, defaultValue: T, addIfNotExists: boolean): T;
        function setProperty<T>(target: any, propertyName: string, value: T): void;
        function checkPropertyAccess(target: any, propertyName: string, access: PropertyAccess): boolean;
        function getAllPrototypesOf(target: any): Object[];
        function invokeAll(target: any, name: string, ...args: any[]): any[];
        function getAndCombineAll<T extends {}>(target: any, propertyName: string): T;
        function parameterNames(func: Function): string[];
        function areDeepEqual(source: any, target: any): boolean;
        function areDeepEqual(source: any, target: any, customComparer: (objA: any, objB: any) => boolean | void): boolean;
        function areShallowEqual(source: any, target: any): boolean;
        function areShallowEqual(source: any, target: any, customComparer: (objA: any, objB: any) => boolean | void): boolean;
        function wrapMethod<T extends Function, R>(target: object, method: T, delegate: (originalFunc: T, args: any[]) => R): R;
        function hashesOf(target: any): number[];
        function typeOf<T>(value: T): ITypeOf<T>;
    }
}
//# sourceMappingURL=reflect.d.ts.map